codeunit 70035 "Whse. Shipment Adjust SBIESS"
{


    [EventSubscriber(ObjectType::Report, Report::"Get Source Documents", 'OnSalesLineOnAfterGetRecordOnBeforeCreateShptHeader', '', false, false)]
    local procedure CheckForCustShipTo(SalesLine: Record "Sales Line"; var WarehouseRequest: Record "Warehouse Request"; var WarehouseShipmentHeader: Record "Warehouse Shipment Header"; var WhseHeaderCreated: Boolean; var OneHeaderCreated: Boolean; var IsHandled: Boolean)
    begin
        if IsHandled then
            exit;

        WarehouseShipmentHeader.Reset();
        WarehouseShipmentHeader.SetRange(WarehouseShipmentHeader."Customer No. SBIESS", SalesLine."Sell-to Customer No.");
        WarehouseShipmentHeader.SetRange(WarehouseShipmentHeader."Ship-To Code SBIESS", SalesLine."Ship-To Code SBIESS");
        WarehouseShipmentHeader.SetRange(Status, WarehouseShipmentHeader.Status::Open);
        // If there IS a Warehouse Shipment for this combination of Cust/Ship-To, then we can skip creation and all is well:
        if WarehouseShipmentHeader.FindFirst() then begin
            WhseHeaderCreated := true;
        end else
            // if NOT, then we can simply tell the Warehouse Engine that it still needs to make a new shipment
            WhseHeaderCreated := false;
    end;


    // After a Warehouse Shipment Header is created from a Sales Line, populate the Cust/Ship-To info so we can filter on it later
    [EventSubscriber(ObjectType::Report, Report::"Get Source Documents", 'OnSalesLineOnAfterCreateShptHeader', '', true, true)]
    local procedure MakeShipmentsCustShipToSpecific(var WhseShptHeader: Record "Warehouse Shipment Header"; WhseHeaderCreated: Boolean; SalesHeader: Record "Sales Header"; SalesLine: Record "Sales Line"; WarehouseRequest: Record "Warehouse Request")
    begin
        WhseShptHeader."Customer No. SBIESS" := SalesLine."Sell-to Customer No.";
        WhseShptHeader."Ship-To Code SBIESS" := SalesLine."Ship-To Code SBIESS";
        WhseShptHeader.Modify();
    end;


}
